chiark / gitweb /
dgit: Enforce a syntax for nominal distros
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 funcs: ${FUNCNAME[*]}
16 lines: ${BASH_LINENO[*]}
17 files: ${BASH_SOURCE[*]}
18 END
19         exit 16
20 }
21
22 trap 'test $? = 0 || t-report-failure' EXIT
23
24 t-filter-out-git-hyphen-dir
25
26 t-set-intree
27
28 : ${DGIT_TEST_DEBUG=-D}
29 export DGIT_TEST_DEBUG
30
31 export GIT_COMMITTER_DATE='1440253867 +0100'
32 export GIT_AUTHOR_DATE='1440253867 +0100'
33
34 root=`pwd`
35 troot=$root/tests
36 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
37
38 tmp=$ADTTMP
39 if [ x"$tmp" = x ]; then
40         mkdir -p tests/tmp
41         tmpbase=$troot/tmp
42         tmp=tests/tmp/$testname
43         rm -rf $tmp
44         mkdir $tmp
45 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
46         tmpbase="$DGIT_TEST_TMPBASE"
47 fi
48 cd $tmp
49
50 tmp=`pwd`
51
52 t-set-using-tmp
53
54 env -0 >$tmp/.save-env
55
56 ln -f $troot/ssh ssh
57
58 export DEBCHANGE_VENDOR=dpkg
59
60 mkdir -p $tmp/incoming
61 cat <<END >$tmp/dput.cf
62 [test-dummy]
63 method                  = local
64 incoming                = $tmp/incoming
65 run_dinstall            = 0
66 END
67
68 : ${t_archive_method:=aq}
69 : ${tagpfx:=archive/test-dummy}
70 : ${suitespecs:=sid:unstable}
71
72 t-git-next-date () {
73         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
74         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
75 }
76
77 t-expect-fail () {
78         local mpat="$1"; shift
79
80         set +o pipefail
81         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
82         local ps="${PIPESTATUS[*]}"
83         set -o pipefail
84
85         case $ps in
86         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
87         *" 0")  ;;
88         *)      fail "tee failed"  ;;
89         esac
90
91         t-grep-mpat "$mpat" $tmp/t.output
92 }
93
94 t-grep-mpat () {
95         local mpat="$1"
96         local file="$2"
97
98         local grepper=fgrep
99         case "$mpat" in
100         [A-Z]:*)
101                 case "$mpat" in
102                 E:*)    grepper=egrep   ;;
103                 F:*)    grepper=fgrep   ;;
104                 *)      fail "bad mpat prefix in $mpat";;
105                 esac
106                 mpat=${mpat#[A-Z]:}
107                 ;;
108         esac
109
110         $grepper -e "$mpat" "$file" ||
111                 fail "message not found"
112 }
113
114 t-expect-push-fail () {
115         local mpat="$1"; shift
116
117         local triedpush; triedpush=`git rev-parse HEAD`
118
119         t-reporefs pre-push
120         t-expect-fail "$mpat"  "$@"
121         t-reporefs post-push
122         diff $tmp/show-refs.{pre,post}-push
123
124         t-git-objects-not-present '' $triedpush
125
126         eval "$t_expect_push_fail_hook"
127 }
128
129 t-git-objects-not-present () {
130         # t-git-objects-not-present GITDIR|'' OBJID [...]
131         # specifying '' means the repo for package $p
132         local gitdir="${1-$dgitrepo}"
133         local obj
134         if ! [ -e "$gitdir" ]; then return; fi
135         for obj in "$@"; do
136                 GIT_DIR=$gitdir \
137                 t-expect-fail 'unable to find' \
138                 git cat-file -t $obj
139         done
140 }
141
142 t-reporefs () {
143         local whichoutput=$1; shift
144         local whichrepo=${1-$dgitrepo}
145         local outputfile="$tmp/show-refs.$whichoutput"
146         (set -e
147          exec >"$outputfile"
148          if test -d $whichrepo; then
149                 cd $whichrepo
150                 git show-ref |sort
151         fi)
152 }
153
154 t-untar () {
155         local tarfile=$1.tar
156         local edittree=$1.edit
157         if test -d "$edittree"; then
158                 cp -a "$edittree"/* .
159         else
160                 tar xf "$tarfile"
161         fi
162 }
163
164 t-worktree () {
165         rm -rf $p
166         t-untar $troot/worktrees/${p}_$1
167 }
168
169 t-select-package () {
170         p=$1
171         dgitrepo=$tmp/git/$p.git
172 }
173
174 t-git () {
175         t-select-package $1
176         v=$2
177         mkdir -p $tmp/git
178         local gs=$troot/git-srcs/${p}_$v.git
179         (set -e; cd $tmp/git; t-untar $gs)
180 }
181
182 t-git-none () {
183         mkdir -p $tmp/git
184         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
185 }
186
187 t-git-merge-base () {
188         git merge-base $1 $2 || test $? = 1
189 }
190
191 t-has-ancestor () {
192         # t-has-ancestor ANCESTOR
193         # (CHILD is implicit, HEAD)
194         local now;      now=`git rev-parse HEAD`
195         local ancestor; ancestor=`git rev-parse $1^{}`
196         local mbase;    mbase=`t-git-merge-base $ancestor $now`
197         if [ x$mbase != x$ancestor ]; then
198                 fail "not ff $ancestor..$now, $mbase != $ancestor"
199         fi
200 }
201
202 t-has-parent-or-is () {
203         # t-has-parent-or-is CHILD PARENT
204         local child=$1
205         local parent=$2
206         local parents
207         parents=$(git show --pretty=format:' %P %H ' "$child")
208         parent=$(git rev-parse "$parent~0")
209         case "$parents" in
210         *" $parent "*)  ;;
211         *)      fail "child $child lacks parent $parent" ;;
212         esac
213 }
214
215 t-prep-newpackage () {
216         t-select-package $1
217         v=$2
218         t-archive-none $p
219         t-git-none
220         t-worktree $v
221         cd $p
222         if ! git show-ref --verify --quiet refs/heads/master; then
223                 git branch -m dgit/sid master
224                 git remote rm dgit
225         fi
226         cd ..
227 }
228
229 t-archive-none () {
230         t-select-package $1
231         t-archive-none-$t_archive_method
232 }
233 t-archive-none-aq () {
234         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
235
236         : >$tmp/aq/suites
237         local jsondelim="["
238
239         local suitespec
240         for suitespec in $suitespecs; do
241                 local suite=${suitespec%%:*}
242                 local sname=${suitespec#*:}
243
244                 >$tmp/aq/package.$suite.$p
245                 t-aq-archive-updated $suite $p
246
247                 >$tmp/aq/package.new.$p
248                 t-aq-archive-updated new $p
249
250                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
251
252                 cat <<END >>$tmp/aq/suites
253 $jsondelim
254    {
255       "archive" : "ftp-master",
256       "codename" : "$suite",
257       "components" : [
258          "main",
259          "contrib",
260          "non-free"
261       ],
262       "name" : "$sname",
263       "dakname" : "$sname"
264 END
265
266                 jsondelim="   },"
267
268         done
269         cat <<END >>$tmp/aq/suites
270     }
271 ]
272 END
273 }
274
275 t-aq-archive-updated () {
276         local suite=$1
277         local p=$2
278         local suitedir=$tmp/aq/dsc_in_suite/$suite
279         mkdir -p $suitedir
280         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
281                 use JSON;
282                 use strict;
283                 our @v;
284                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
285                 push @v, {
286                         "version" => "$1",
287                         "sha256sum" => "$2",
288                         "component" => "$3",
289                         "filename" => "$4",
290                 };
291                 END {
292                         my $json = JSON->new->canonical();
293                         print $json->encode(\@v) or die $!;
294                 }
295         '
296 }
297
298 t-archive-process-incoming () {
299         local suite=$1
300         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
301         t-archive-query "$suite"
302 }
303
304 t-archive-query () {
305         local suite=${1-sid}
306         local dscf=main/${p}_${v}.dsc
307         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
308 }
309 t-archive-query-aq () {
310         local suite=$1
311         local p=$2
312         local v=$3
313         local dscf=$4
314         local sha; sha=`sha256sum <$tmp/mirror/pool/$dscf`
315         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
316         t-aq-archive-updated $suite $p
317 }
318
319 t-archive () {
320         t-archive-none $1
321         v=$2
322         local dscf=${p}_$2.dsc
323         rm -f $tmp/mirror/pool/main/${p}_*
324         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
325         t-archive-query $suite
326         rm -rf $tmp/extract
327         mkdir $tmp/extract
328         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
329 }
330
331 t-git-dir-time-passes () {
332         touch -d 'last year' $dgitrepo
333 }
334
335 t-git-dir-check () {
336         local gitdir=$dgitrepo
337         case "$1" in
338         enoent)
339                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
340                 return
341                 ;;
342         public) wantstat='7[75]5' ;;
343         secret) wantstat='7[70]0' ;;
344         *)      fail "$1 t-git-dir-check ?" ;;
345         esac
346         gotstat=`stat -c%a $gitdir`
347         case "$gotstat" in
348         *$wantstat) return ;;
349         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
350         esac
351 }
352
353 t-expect-fsck-fail () {
354         echo >>$tmp/fsck.expected-errors "$1"
355 }
356
357 t-git-fsck () {
358         set +e
359         LC_MESSAGES=C git fsck --no-dangling --strict 2>&1 \
360                 | tee dgit-test-fsck.errs
361         ps="${PIPESTATUS[*]}"
362         set -e
363
364         local pats
365         if [ -f $tmp/fsck.expected-errors ]; then
366                 pats=(-w -f $tmp/fsck.expected-errors)
367         else
368                 test "$ps" = "0 0"
369         fi
370         pats+=(-e 'notice: HEAD points to an unborn branch')
371         pats+=(-e 'notice: No default references')
372
373         set +e
374         grep -v "${pats[@]}" dgit-test-fsck.errs
375         rc=$?
376         set -e
377         case $rc in
378         1) ;; # no unexpected errors
379         0) fail "unexpected messages from git-fsck" ;;
380         *) fail "grep of git-fsck failed" ;;
381         esac
382 }
383
384 t-fscks () {
385         (
386         shopt -s nullglob
387         for d in $tmp/*/.git $tmp/git/*.git; do
388                 cd "$d"
389                 t-git-fsck
390         done
391         )
392 }
393
394 t-ok () {
395         t-fscks
396         echo ok.
397 }
398
399 t-rm-dput-dropping () {
400         rm -f $tmp/${p}_${v}_*.upload
401 }
402
403 t-dgit () {
404         local dgit=${DGIT_TEST-dgit}
405         pwd
406         : '
407 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
408         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
409                 ${distro--dtest-dummy} ${distro+${distro:+-d}${distro}} \
410                 $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
411                 -k39B13D8A $t_dgit_xopts "$@"
412         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
413 '
414 }
415
416 t-diff-nogit () {
417         diff --exclude=.git --exclude=.pc -ruN $*
418 }
419
420 t-files-notexist () {
421         local f
422         for f in "$@"; do
423                 if [ -e $f ]; then
424                         fail "$f exists!"
425                 fi
426         done
427 }
428
429 t-cloned-fetched-good () {
430         t-diff-nogit ../extract/$p-${v%-*} .
431         t-clean-on-branch dgit/sid
432         t-refs-same-start
433         t-refs-same \
434                 refs/heads/dgit/sid \
435                 refs/remotes/dgit/dgit/sid
436         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
437 }
438
439 t-output () {
440         printf "%s${1:+\n}" "$1" >$tmp/t.want
441         shift
442         "$@" >$tmp/t.got
443         diff $tmp/t.want $tmp/t.got
444 }
445
446 t-clean-on-branch () {
447         t-output "## $1" git status -b --porcelain
448 }
449
450 t-setup-done () {
451         local savevars=$1
452         local savedirs=$2
453         local importeval=$3
454
455         local import=IMPORT.${0##*/}
456         exec 4>$tmp/$import.new
457
458         local vn
459         for vn in $savevars; do
460                 perl >&4 -I. -MDebian::Dgit -e '
461                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
462                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
463         done
464
465         (set -e; cd $tmp; tar cf $import.tar $savedirs)
466
467         printf >&4 "\n%s\n" "$importeval"
468
469         mv -f $tmp/$import.new $tmp/$import
470 }
471
472 t-setup-import () {
473         local setupname=$1
474
475         local setupsrc
476         local lock
477         if [ "x$tmpbase" = x ]; then
478                 # ADTTMP was set on entry to tests/lib, so we
479                 # are not sharing tmp area between tests
480                 setupsrc="$tmp"
481                 lock="$tmp/.dummy.lock"
482         else
483                 setupsrc="$tmpbase/$setupname"
484                 lock="$setupsrc.lock"
485         fi
486
487         local simport="$setupsrc/IMPORT.$setupname"
488
489         if ! [ -e "$simport" ]; then
490                 with-lock-ex -w "$lock" \
491                 xargs -0 -a $tmp/.save-env \
492                 bash -xec '
493                         cd "$1"; shift
494                         setupname="$1"; shift
495                         simport="$1"; shift
496                         if [ -e "$simport" ]; then exit 0; fi
497                         env - "$@" \
498                         "tests/setup/$setupname"
499                 ' x "$root" "$setupname" "$simport"
500         fi
501
502         if [ "x$setupsrc" != "x$tmp" ]; then
503                 (set -e; cd $tmp; tar xf "$simport.tar")
504         fi
505
506         . "$simport"
507 }
508
509 t-git-get-ref-exact () {
510         local ref=$1
511         # does not dereference, unlike t-git-get-ref
512         case "$ref" in
513         refs/*) ;;
514         *) fail "t-git-get-ref-exact bad $ref" ;;
515         esac
516         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
517 }
518
519 t-git-get-ref () {
520         local ref=$1
521         case "$ref" in
522         refs/*) ;;
523         *) fail "t-git-get-ref bad $ref" ;;
524         esac
525         (git show-ref -d $1 || test $? = 1) | perl -ne '
526                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
527                 END { print "$x\n" if length $x; }
528         '
529 }
530
531 t-ref-same-exact () {
532         local name="$1"
533         local val; val=`t-git-get-ref-exact $name`
534         t-ref-same-val "$name" $val
535 }
536
537 t-ref-same () {
538         local name="$1"
539         local val; val=`t-git-get-ref $name`
540         t-ref-same-val "$name" $val
541 }
542
543 t-ref-head () {
544         local val; val=`git rev-parse HEAD`
545         t-ref-same-val HEAD $val
546 }
547
548 t-ref-same-val () {
549         local name="$1"
550         local val=$2
551         case "${t_ref_val-unset}" in
552         unset)          ;;
553         "$val")         ;;
554         *)              fail "ref varies: ($name)\
555  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
556         esac
557         t_ref_val="$val"
558         t_ref_names+=("$name")
559 }
560
561 t-refs-same-start () {
562         unset t_ref_val
563         t_ref_names=()
564 }
565
566 t-refs-same () {
567         local g
568         for g in $*; do
569                 t-ref-same $g
570         done
571 }
572
573 t-refs-notexist () {
574         local val
575         for g in $*; do
576                 val=`t-git-get-ref $g`
577                 if [ "x$val" != x ]; then
578                         fail "ref $g unexpectedly exists ($val)"
579                 fi
580         done
581 }
582
583 t-v-tag () {
584         echo refs/tags/$tagpfx/${v//\~/_}
585 }
586
587 t-format-ref () {
588         git log -n1 --pretty=format:"$1" "$2"
589 }
590
591 t-sametree-parent () {
592         local ref=$1
593         local parent
594         local ctree; ctree=$(t-format-ref '%T' "$ref")
595         while :; do
596                 local psame=''
597                 for parent in $(t-format-ref '%P' "$ref"); do
598                         local ptree; ptree=$(t-format-ref '%T' "$parent")
599                         if [ "x$ptree" = "x$ctree" ]; then
600                                 psame+=" $parent"
601                         fi
602                 done
603                 case "$psame" in ""|" * *") break ;; esac
604                 ref="${psame# }"
605         done
606         echo "$ref"
607 }
608
609 t-check-pushed-master () {
610         local master; master=`t-git-get-ref refs/heads/master`
611         if [ x$master = x$t_ref_val ]; then return; fi
612         if [ x$master = x ]; then fail "failed to push master"; fi
613         # didn't update master, it must be not FF
614         local mbase; mbase=`t-git-merge-base $master $t_ref_val`
615         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
616 }
617
618 t-pushed-good () {
619         local branch=$1
620         local suite=${2:-sid}
621         t-refs-same \
622                 refs/heads/$branch
623         t-pushed-good-core
624 }
625         
626 t-pushed-good-core () {
627         t-ref-dsc-dgit
628         t-refs-same \
629                 `t-v-tag` \
630                 refs/remotes/dgit/dgit/$suite
631         t-refs-notexist \
632                 refs/heads/dgit/unstable \
633                 refs/remotes/dgit/dgit/unstable
634         (set -e; cd $dgitrepo
635          t-refs-same \
636                 refs/dgit/$suite \
637                 `t-v-tag`
638          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
639          t-refs-notexist \
640                 refs/dgit/unstable
641         )
642         git verify-tag `t-v-tag`
643 }
644
645 t-splitbrain-pushed-good--unpack () {
646         cd $tmp
647         rm -rf t-unpack
648         mkdir t-unpack
649         cd t-unpack
650         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
651         ln -s $tmp/incoming/*.orig*.tar* . ||:
652         ln -s $incoming_dsc .
653         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
654         dpkg-source "$@" -x *.dsc
655         cd */.
656         git init
657         git fetch ../../$p "refs/tags/*:refs/tags/*"
658 }
659
660 t-splitbrain-pushed-good--checkprep () {
661         git add -Af .
662         git rm --cached -r --ignore-unmatch .pc
663 }
664
665 t-splitbrain-pushed-good--checkdiff () {
666         local tag=$1
667         t-splitbrain-pushed-good--checkprep
668         t-output "" git diff --stat --cached $tag
669 }
670
671 t-splitbrain-pushed-good-start () {
672         dep14tag=refs/tags/test-dummy/${v//\~/_}
673         dgittag=$(t-v-tag)
674         t-output "" git status --porcelain
675         t-ref-head
676         t-refs-same $dep14tag
677         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
678         git merge-base --is-ancestor $dep14tag $dgittag
679
680         t-refs-same-start
681         t-ref-same refs/heads/split.p
682         case "$(t-git-get-ref refs/heads/split.b)" in
683         "$t_ref_val") ;;
684         "$(git rev-parse refs/heads/split.p^0)") ;;
685         "$(git rev-parse refs/heads/split.p^1)") ;;
686         *) fail 'bad b/p' ;;
687         esac
688         t-pushed-good-core
689
690         t-incoming-dsc
691
692         t-splitbrain-pushed-good--unpack
693         t-splitbrain-pushed-good--checkdiff $dgittag
694 }
695 t-splitbrain-pushed-good-end-made-dep14 () {
696         t-splitbrain-pushed-good--checkdiff $dep14tag
697         cd $tmp/$p
698 }
699
700 t-splitbrain-rm-gitignore-patch () {
701         perl -i -pe '
702                 next unless $_ eq "auto-gitignore\n";
703                 die if $counter++;
704                 chomp;
705                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
706                 $_ = "";
707         ' debian/patches/series
708 }
709
710 t-gbp-pushed-good () {
711         local suite=${1:-sid}
712         t-splitbrain-pushed-good-start
713
714         # Right, now we want to check that the maintainer tree and
715         # the dgit tree differ in exactly the ways we expect.  We
716         # achieve this by trying to reconstruct the maintainer tree
717         # from the dgit tree.
718
719         # So, unpack it withut the patches applied
720         t-splitbrain-pushed-good--unpack --skip-patches
721
722         # dgit might have added a .gitignore patch, which we need to
723         # drop and remove
724         t-splitbrain-rm-gitignore-patch
725
726         # Now the result should differ only in non-debian/ .gitignores
727         t-splitbrain-pushed-good--checkprep
728         git diff --cached --name-only $dep14tag >../changed
729         perl -ne '
730                 next if !m#^debian/# && m#(^|/)\.gitignore#;
731                 die "$_ mismatch";
732         ' <../changed
733
734         # If we actually apply the gitignore patch by hand, it
735         # should be perfect:
736         if [ -f ../t-auto-gitignore ]; then
737                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
738         fi
739
740         t-splitbrain-pushed-good-end-made-dep14
741 }
742
743 t-unapplied-pushed-good () {
744         t-splitbrain-pushed-good-start
745         t-splitbrain-pushed-good--unpack --skip-patches
746         t-splitbrain-pushed-good-end-made-dep14
747 }
748
749 t-dpm-pushed-good () {
750         t-splitbrain-pushed-good-start
751         t-splitbrain-pushed-good--unpack
752         t-splitbrain-rm-gitignore-patch
753         t-splitbrain-pushed-good-end-made-dep14
754 }
755
756 t-commit-build-push-expect-log () {
757         local msg=$1
758         local mpat=$2
759         t-commit "$msg"
760         t-dgit build
761         LC_MESSAGES=C \
762         t-dgit push --new 2>&1 |tee $tmp/push.log
763         t-grep-mpat "$mpat" $tmp/push.log
764 }
765
766 t-822-field () {
767         local file=$1
768         local field=$2
769         perl -e '
770                 use Dpkg::Control::Hash;
771                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
772                 $h->parse(\*STDIN,"'"$file"'");
773                 my $val = $h->{"'$field'"},"\n";
774                 die "'"$file $field"'" unless defined $val;
775                 print $val,"\n";
776         ' <$file
777 }
778
779 t-stunt-envvar () {
780         local var=$1
781         local tstunt=$2
782         eval '
783                 case "$'$var'" in
784                 "$tstunt:"*)    ;;
785                 *":$tstunt:"*)  ;;
786                 "")             '$var'="$tstunt" ;;
787                 *)              '$var'="$tstunt:$'$var'" ;;
788                 esac
789                 export '$var'
790         '
791 }
792
793 t-tstunt--save-real () {
794         local f="$1"
795         case "$f" in
796         */*) return ;;
797         esac
798
799         local rc
800         local real
801         set +e
802         real=$(type -p "$f")
803         rc=$?
804         set -e
805
806         case $rc in
807         1)      return ;;
808         0)      ;;
809         *)      fail "did not find $f on PATH $PATH" ;;
810         esac
811
812         local varname=${f//[^_0-9a-zA-Z]/_}
813         varname=DGIT_TEST_REAL_${varname^^}
814
815         eval "
816                 : \${$varname:=\$real}
817                 export $varname
818         "
819 }
820
821 t-tstunt () {
822         local tstunt=$tmp/tstunt
823         t-stunt-envvar PATH $tstunt
824         t-stunt-envvar PERLLIB $tstunt
825         local f
826         for f in "$@"; do
827                 t-tstunt--save-real $f
828                 f="./$f"
829                 local d="$tstunt/${f%/*}"
830                 mkdir -p $d
831                 ln -sf "$troot/tstunt/$f" "$d"/.
832         done
833 }
834
835 t-tstunt-parsechangelog () {
836         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
837 }
838
839 t-tstunt-lintian () {
840         t-tstunt lintian
841 }
842
843 t-tstunt-debuild () {
844         t-tstunt debuild
845 }
846
847 t-incoming-dsc () {
848         local dsc=${p}_${v}.dsc
849         incoming_dsc=$tmp/incoming/$dsc
850 }
851
852 t-ref-dsc-dgit () {
853         t-incoming-dsc
854         local val; val=`t-822-field $incoming_dsc Dgit`
855         val=$( perl -e '
856                 $_=shift @ARGV;
857                 die "Dgit $_ ?" unless m/^\w+\b/;
858                 print $&,"\n" or die $!;
859         ' "$val")
860         t-ref-same-val $incoming_dsc "$val"
861 }
862
863 t-apply-diff () {
864         local v1=$1
865         local v2=$2
866         (cd $troot/pkg-srcs;
867          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
868          | patch -p1 -u
869 }
870
871 t-gbp-unapplied-pq2qc () {
872         # does `gbp pq export'
873         # commits the resulting debian/patches on  qc/BRANCH
874         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
875         # qc/BRANCH is not fast-forwarding
876
877         gbp pq export
878
879         branch=`git symbolic-ref HEAD`
880         branch=${branch#refs/heads/}
881
882         case "$branch" in
883         */*) fail "unexpected branch $branch" ;;
884         esac
885
886         git branch -f qc/$branch
887         git checkout qc/$branch
888         git add debian/patches
889         git commit -m 'Commit patch queue'
890 }
891
892 t-git-pseudo-merge () {
893         # like   git merge -s ours
894         if [ ! "$git_pseuomerge_opts" ]; then
895                 if git merge --help \
896                  | grep -q allow-unrelated-histories; then
897                         git_pseuomerge_opts='--allow-unrelated-histories'
898                 fi
899                 git_pseuomerge_opts+=' -s ours'
900         fi
901         git merge $git_pseuomerge_opts "$@"
902 }
903
904 t-gbp-example-prep-no-ff () {
905         t-tstunt-parsechangelog
906         t-archive example 1.0-1
907         t-git-none
908         t-worktree 1.0
909
910         cd example
911
912         t-dgit fetch
913
914         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
915         gbp pq rebase
916
917         echo '/* some comment */' >>src.c
918         git add src.c
919         git commit -m 'Add a comment to an upstream file'
920
921         t-gbp-unapplied-pq2qc
922
923         t-commit 'some updates' 1.0-2
924 }
925
926 t-gbp-example-prep () {
927         t-gbp-example-prep-no-ff
928
929         t-git-pseudo-merge \
930                 -m 'Pseudo-merge to make descendant of archive' \
931                 remotes/dgit/dgit/sid
932 }
933
934 t-make-badcommit () {
935         badcommit=$(
936                 git cat-file commit HEAD | \
937                 perl -pe 's/^committer /commiter /' | \
938                 git hash-object -w -t commit --stdin
939         )
940         t-expect-fsck-fail $badcommit
941 }
942
943 t-commit () {
944         local msg=$1
945         v=${2:-${majorv:-1}.$revision}
946         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
947         git add debian/changelog
948         debcommit
949         revision=$(( ${revision-0} + 1 ))
950 }
951
952 t-git-config () {
953         git config --global "$@"
954 }
955
956 t-drs () {
957         export DGIT_TEST_TROOT=$troot
958  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
959  t-git-config dgit-distro.test-dummy.git-check true
960  t-git-config dgit-distro.test-dummy.git-create true
961  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
962         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
963         cp $troot/suites $tmp/.
964         cp $troot/suites $tmp/suites-master
965
966         export t_check_pushed_master=t-check-pushed-master
967
968         drs_dispatch=$tmp/distro=test-dummy
969         mkdir $drs_dispatch
970
971         if [ "x$DGIT_TEST_INTREE" != x ]; then
972                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
973         fi
974
975         ln -sf $tmp/git $drs_dispatch/repos
976         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
977         mkdir -p $drs_dispatch/keyrings
978         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
979         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
980         ln -sf /bin/true $drs_dispatch/policy-hook
981 }
982
983 t-newtag () {
984  export tagpfx=archive/test-dummy
985  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
986 }
987 t-oldtag () {
988  export tagpfx=test-dummy
989  t-git-config dgit-distro.test-dummy.dgit-tag-format old
990 }
991
992 t-dsd () {
993         t-drs
994  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
995  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
996  t-git-config dgit-distro.test-dummy.git-create true
997  t-git-config dgit-distro.test-dummy.git-url \
998                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
999
1000  t-git-config dgit-distro.test-dummy.diverts.drs /drs
1001  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
1002  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
1003  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
1004  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
1005
1006         echo 'no-such-package* drs' >$drs_dispatch/diverts
1007 }
1008
1009 t-policy-admin () {
1010         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
1011 }
1012
1013 t-policy-nonexist () {
1014         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
1015 }
1016
1017 t-make-hook-link () {
1018         local hook=$1 # in infra/
1019         local linkpath=$2
1020         hook=${DGIT_INFRA_PFX}$hook
1021         case $hook in
1022         */*)    ;;
1023         *)      hook=`type -P $hook` ;;
1024         esac
1025         ln -sf "$hook" $linkpath
1026 }
1027
1028 t-policy () {
1029         local policyhook=$1
1030         t-make-hook-link $policyhook $drs_dispatch/policy-hook
1031 }
1032
1033 t-debpolicy () {
1034         t-dsd
1035         t-policy dgit-repos-policy-debian
1036
1037         mkdir $tmp/git
1038         t-policy-admin create-db
1039 }
1040
1041 t-policy-periodic () {
1042         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
1043                 test-dummy $drs_dispatch '' --cron
1044 }
1045
1046 t-restrict () {
1047         local restriction=$1
1048         (cd $root; t-restriction-$restriction >&2)
1049 }
1050
1051 t-dependencies () {
1052         : "Hopefully installed: $*"
1053 }
1054
1055 t-chain-test () {
1056         local ct=$1
1057         local d=${0%/*}
1058         cd $root
1059         export DGIT_TEST_TESTNAME="$testname"
1060         export DGIT_TEST_TMPBASE="$tmpbase"
1061         export ADTTMP=$tmp
1062         exec "$d/$ct"
1063 }       
1064
1065 t-alt-test () {
1066         local t=${0##*/}
1067         t-${t%%-*}
1068         t-chain-test "${t#*-}"
1069 }
1070
1071 case "$0" in
1072 */gnupg) ;;
1073 *)      t-setup-import gnupg    ;;
1074 esac